
//void open_all(HANDLE* in_h, HANDLE* out_h, ) {

//    ULONG read_bytes;

    if(automated && !list_msg) {
        i = xcslen(in_name);

        // my.tbi -> my.bkp.tbi
        bkp_name = (XCHAR*)GlobalAlloc(GMEM_FIXED, (i+10)*sizeof(XCHAR));
        bkp2_name = (XCHAR*)GlobalAlloc(GMEM_FIXED, (i+10)*sizeof(XCHAR));
        if(!bkp_name || !bkp2_name) {
            xprintf(XT("Can't allocate memory for filename\n")
                   XT("exiting...\n"));
            exit (-2);
        }
        xstrcpy(bkp_name, in_name);
        sptr = xcsrchr(bkp_name, '.');
        if(!sptr) {
            xprintf(XT("Can't find filename extension in %s\n")
                   XT("exiting...\n"), in_name);
            exit (-1);
        }
        xstrcpy(sptr, XT(".tbi")); // bkp_name = 'my.tbi'
        xstrcpy(bkp2_name, bkp_name); // bkp2_name = 'my.tbi'
        xstrcpy(sptr, XT(".bkp.tbi")); // bkp_name = 'my.bkp.tbi'

        i = MoveFileX(bkp2_name, bkp_name);
        if(!i) {
            HANDLE bkp_h;
            xprintf(XT("Can't make backup %s -> \n  %s\n")
                   XT("exiting...\n"), bkp2_name, bkp_name);

            bkp_h = CreateFileX(bkp2_name, GENERIC_READ, FILE_SHARE_READ, NULL,
                              OPEN_EXISTING,
                              FILE_ATTRIBUTE_NORMAL,
                              NULL);
            if(bkp_h == (HANDLE)(-1)) {
              CloseHandle(bkp_h);
              printf("Doesn't exists. Ignoring...\n");
            } else {
              exit (-2);
            }
        }

        // my.tdd -> my.bkp.tbb
        xstrcpy(sptr, XT(".bkp.tbb")); // bkp_name = 'my.bkp.tbb'
        i = MoveFileX(in_name, bkp_name);
        if(!i) {
            xprintf(XT("Can't make backup %s -> \n  %s\n")
                   XT("exiting...\n"), in_name, bkp_name);

            // try roll back TDI backup
            xstrcpy(sptr, XT(".tbi")); // bkp_name = 'my.tbi'
            xstrcpy(bkp2_name, bkp_name); // bkp2_name = 'my.tbi'
            xstrcpy(sptr, XT(".bkp.tbi")); // bkp_name = 'my.bkp.tbi'
            MoveFileX(bkp_name, bkp2_name); 
            exit (-2);
        }

        // in_name -> my.bkp.tbb
        // out_name -> my.tbb
        out_name = in_name;  // in_name = 'my.bkp.tbb'
        in_name = bkp_name;  // out_name = 'my.tbb'
    }

    in_h = CreateFileX(in_name, GENERIC_READ, FILE_SHARE_READ, NULL,
                      OPEN_EXISTING,
                      FILE_ATTRIBUTE_NORMAL | (no_cache ? FILE_FLAG_NO_BUFFERING : 0) | FILE_FLAG_SEQUENTIAL_SCAN,
                      NULL);
    if(in_h == (HANDLE)(-1)) {
        xprintf(XT("Can't open source file %s\n")
               XT("exiting...\n"), in_name);
        read_bytes = GetLastError();
        exit (-1);
    }

    if(!list_msg) {
        if(!xstrcmp(out_name, XT("nul"))) {
            out_is_nul = TRUE;
        }
        out_h = CreateFileX(out_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL | (no_cache ? FILE_FLAG_NO_BUFFERING : 0) /* | FILE_FLAG_SEQUENTIAL_SCAN*/,
                          NULL);
        if(out_h == (HANDLE)(-1)) {
            new_target = TRUE;
            out_h = CreateFileX(out_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ,
                              NULL,
                              OPEN_ALWAYS,
                              FILE_ATTRIBUTE_NORMAL | (no_cache ? FILE_FLAG_NO_BUFFERING : 0) /*| FILE_FLAG_SEQUENTIAL_SCAN*/,
                              NULL);
            if(out_h == (HANDLE)(-1)) {
                read_bytes = GetLastError();
                xprintf(XT("Can't open or create target file %s\n")
                       XT("exiting...\n"), out_name);
                exit (-3);
            }
        }
    } else {
        out_is_nul = TRUE;
    }

//} // end open_all()